SystemOrganization addCategory: #'Keymapping-Settings'!

!SettingNodeBuilder methodsFor: '*Keymapping-Settings' stamp: 'GuillermoPolito 5/31/2011 12:29'!
category: aByteSymbol 
	node item categoryName: aByteSymbol! !

!SettingNodeBuilder methodsFor: '*Keymapping-Settings' stamp: 'GuillermoPolito 2/15/2011 23:29'!
do: aBlockClosure 
	node item action: aBlockClosure ! !

!SettingNodeBuilder methodsFor: '*Keymapping-Settings' stamp: 'GuillermoPolito 5/31/2011 13:54'!
shortcutName: aShortcutName
	node item shortcutName: aShortcutName! !

!SettingTreeBuilder methodsFor: '*Keymapping-Settings' stamp: 'GuillermoPolito 3/13/2011 17:58'!
attachShortcutCategory: aByteSymbol to: aClass
	KMFactory keymapContainer attachCategoryName: aByteSymbol to: aClass.! !

!SettingTreeBuilder methodsFor: '*Keymapping-Settings' stamp: 'GuillermoPolito 2/9/2011 23:45'!
shortcut: aShortcutNameSymbol
	^ self nodeClass: KMShortcutDeclaration name: aShortcutNameSymbol! !

Object subclass: #KMSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Settings'!

!KMSettings class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 2/15/2011 23:42'!
defaultSettingsOn: aBuilder  
	<systemsettings>
	(aBuilder group: #keymappings)
		label: 'Keymappings' translated;
		description: 'All Keymappings' translated.! !

Object subclass: #KMShortcutSetting
	instanceVariableNames: 'shortcutName category action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Settings'!

!KMShortcutSetting class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/18/2011 23:11'!
for: aShortcutName in: aCategory
	^ (self new)
		shortcutName: aShortcutName;
		category: aCategory;
		yourself! !

!KMShortcutSetting class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/18/2011 23:11'!
settingInputWidgetForNode: aSettingNode
	| catcherMorph theme |
	theme := UITheme builder.
	catcherMorph := KMCatcherMorph for: aSettingNode realValue.
	^ theme newRow: {catcherMorph}! !

!KMShortcutSetting methodsFor: 'setting' stamp: 'GuillermoPolito 1/24/2011 01:13'!
accept: aShortcut 
	self keymap shortcut: aShortcut! !

!KMShortcutSetting methodsFor: 'accessing' stamp: 'GuillermoPolito 1/24/2011 22:02'!
action: anActionBlock
	action := anActionBlock! !

!KMShortcutSetting methodsFor: 'accessing' stamp: 'GuillermoPolito 1/20/2011 00:55'!
category: aCategory
	category := aCategory! !

!KMShortcutSetting methodsFor: 'accessing' stamp: 'GuillermoPolito 10/18/2011 20:52'!
defaultShortcut
	^ self keymap defaultShortcut! !

!KMShortcutSetting methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 12:43'!
keymap
	^ KMFactory keymapContainer keymapNamed: shortcutName inCategory: category! !

!KMShortcutSetting methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
keystrokes
	^ self keymap shortcut! !

!KMShortcutSetting methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
shortcut
	^ self keymap shortcut! !

!KMShortcutSetting methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 12:46'!
shortcutName: aShortcutName
	shortcutName := aShortcutName! !

SettingDeclaration subclass: #KMShortcutDeclaration
	instanceVariableNames: 'categoryName declaration shortcutName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Settings'!

!KMShortcutDeclaration methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 12:27'!
categoryName
	^categoryName! !

!KMShortcutDeclaration methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 12:27'!
categoryName: aCategoryName
	categoryName := aCategoryName! !

!KMShortcutDeclaration methodsFor: 'accessing' stamp: 'GuillermoPolito 10/18/2011 20:52'!
defaultValue
	^self realValue defaultShortcut! !

!KMShortcutDeclaration methodsFor: 'accessing' stamp: 'GuillermoPolito 9/12/2011 17:45'!
realValue
	"Answer the value of realValue"

	^ declaration
		ifNil: [
			declaration := KMShortcutSetting for: self shortcutName in: self categoryName]! !

!KMShortcutDeclaration methodsFor: 'accessing' stamp: 'GuillermoPolito 10/18/2011 20:58'!
realValue: aShortcut
	self realValue accept: aShortcut.! !

!KMShortcutDeclaration methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 13:54'!
shortcutName
	^shortcutName! !

!KMShortcutDeclaration methodsFor: 'accessing' stamp: 'GuillermoPolito 5/31/2011 13:54'!
shortcutName: aShortcutName
	shortcutName := aShortcutName! !

BorderedMorph subclass: #KMCatcherMorph
	instanceVariableNames: 'focused keystrokes keymapSetting labelMorph initialShortcut edited'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Settings'!

!KMCatcherMorph class methodsFor: 'instance creation' stamp: 'CamilloBruni 3/18/2011 23:11'!
for: aModel
	^ (self new)
		keymapSetting: aModel;
		yourself! !

!KMCatcherMorph methodsFor: 'api' stamp: 'GuillermoPolito 1/24/2011 01:31'!
accept
	| shortcut |
	shortcut := self shortcut.
	keymapSetting accept: shortcut.
	self initialShortcut: shortcut.
	edited := false.! !

!KMCatcherMorph methodsFor: 'event handling' stamp: 'CamilloBruni 3/18/2011 23:11'!
allowsKeymapping
	^ false! !

!KMCatcherMorph methodsFor: 'accessing' stamp: 'CamilloBruni 3/18/2011 23:11'!
balloonText
	^ 'Click to edit shortcut.  Right click to open context menu.'! !

!KMCatcherMorph methodsFor: 'api' stamp: 'CamilloBruni 3/18/2011 23:11'!
cancel
	edited
		ifFalse: [ ^ self ].
	self keystrokes: OrderedCollection new.
	self showInitialShortcut.
	self initializeKeystrokes! !

!KMCatcherMorph methodsFor: 'event handling' stamp: 'GuillermoPolito 1/20/2011 00:50'!
clear
	self keystrokes removeAll.
	self showKeystrokes.! !

!KMCatcherMorph methodsFor: 'drawing' stamp: 'GuillermoPolito 1/24/2011 02:45'!
drawOn: aCanvas
	"Indicate unaccepted edits, conflicts etc."

	super drawOn: aCanvas. 
	focused ifTrue: [
		UITheme current drawTextAdornmentFor: self color: Color orange on: aCanvas]! !

!KMCatcherMorph methodsFor: 'event handling' stamp: 'CamilloBruni 3/19/2011 00:09'!
handlesKeyboard: event
	^ focused! !

!KMCatcherMorph methodsFor: 'event handling' stamp: 'CamilloBruni 3/19/2011 00:09'!
handlesMouseDown: event
	^ true! !

!KMCatcherMorph methodsFor: 'initialization' stamp: 'GuillermoPolito 1/24/2011 01:26'!
initialShortcut: aShortcut
	initialShortcut := aShortcut.
	self showInitialShortcut.
	self initializeKeystrokes.! !

!KMCatcherMorph methodsFor: 'initialization' stamp: 'GuillermoPolito 1/24/2011 02:43'!
initialize
	super initialize.
	self layoutPolicy: TableLayout new.
	self listCentering: #center.
	self width: 300.
	self height: 25.
	self color: (UITheme current textEditorDisabledFillStyleFor: self).
	self borderStyle: (UITheme current textEditorDisabledBorderStyleFor: self).
	
	labelMorph := StringMorph contents: ''.
	self addMorph: (labelMorph).
	
	edited := false.
	focused := false.
	self initializeKeystrokes.
	! !

!KMCatcherMorph methodsFor: 'initialization' stamp: 'GuillermoPolito 1/24/2011 01:26'!
initializeKeystrokes
	keystrokes := OrderedCollection new.! !

!KMCatcherMorph methodsFor: 'event handling' stamp: 'GuillermoPolito 1/24/2011 00:53'!
keyStroke: aKeyStroke 
	edited := true.
	self keystrokes add: aKeyStroke.
	self showKeystrokes.! !

!KMCatcherMorph methodsFor: 'event handling' stamp: 'GuillermoPolito 5/23/2012 11:39'!
keyboardFocusChange: aBoolean
	super keyboardFocusChange: aBoolean.
	focused := aBoolean.
	focused
		ifTrue: [ self color: (UITheme current textEditorNormalFillStyleFor: self) ]
		ifFalse: [ self color: (UITheme current textEditorDisabledFillStyleFor: self) ].
	^ true! !

!KMCatcherMorph methodsFor: 'event handling' stamp: 'GuillermoPolito 5/31/2011 12:42'!
keymapSetting: aSetting
	keymapSetting := aSetting.
	self initialShortcut: keymapSetting shortcut.! !

!KMCatcherMorph methodsFor: 'api' stamp: 'CamilloBruni 3/18/2011 23:11'!
keystrokes
	^ keystrokes! !

!KMCatcherMorph methodsFor: 'api' stamp: 'GuillermoPolito 1/20/2011 01:28'!
keystrokes: someKeystrokes
	keystrokes := someKeystrokes.
	self showKeystrokes.! !

!KMCatcherMorph methodsFor: 'event handling' stamp: 'CamilloBruni 3/19/2011 00:07'!
mouseDown: event 
	super mouseDown: event.
	event yellowButtonPressed 
		ifTrue: [ self showContextMenu ]
		ifFalse: [ World activeHand newKeyboardFocus: self ]! !

!KMCatcherMorph methodsFor: 'accessing' stamp: 'GuillermoPolito 1/20/2011 00:02'!
setMessage: aMessage 
	labelMorph contents: aMessage! !

!KMCatcherMorph methodsFor: 'api' stamp: 'GuillermoPolito 11/2/2011 22:34'!
shortcut
	| theKeystrokes |
	theKeystrokes := self keystrokes.
	theKeystrokes 
		ifEmpty: [ ^ KMNoShortcut new ].
		
	^ theKeystrokes allButFirst 
		inject: theKeystrokes first asShortcut 
		into: [ :acum :each | 
			acum , each asShortcut ]! !

!KMCatcherMorph methodsFor: 'api' stamp: 'CamilloBruni 3/20/2011 23:41'!
shortcutString
	| shortcut |
	self keystrokes 
		ifEmpty: [ ^ '' ].
	shortcut := self shortcut.
	^ shortcut asString! !

!KMCatcherMorph methodsFor: 'event handling' stamp: 'CamilloBruni 3/19/2011 00:06'!
showContextMenu
	| menu |
	menu := MenuMorph new defaultTarget: self.
	
	edited 
		ifTrue: [
			menu add: 'accept' translated action: #accept.
			menu add: 'clear' translated action: #clear.
			menu add: 'cancel' translated action: #cancel.
			].
		
	self theme decorateMenu: menu.
	menu popUpInWorld: self currentWorld! !

!KMCatcherMorph methodsFor: 'initialization' stamp: 'CamilloBruni 3/20/2011 23:49'!
showInitialShortcut
	self setMessage: initialShortcut asString.! !

!KMCatcherMorph methodsFor: 'private' stamp: 'GuillermoPolito 1/24/2011 00:57'!
showKeystrokes
	self setMessage: self shortcutString.! !

!KMCatcherMorph methodsFor: 'halos and balloon help' stamp: 'CamilloBruni 3/18/2011 23:11'!
wantsBalloon
	^ true! !
